unit UT_dmTable;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, ADODB;

type
  TdmTable = class(TDataModule)
    connMain: TADOConnection;
    tblWallboard: TADOTable;
    tblDispseq: TADOTable;
    tblDispColor: TADOTable;
    tblItemType: TADOTable;
    tblSrvGroup: TADOTable;
    tblWallboardLocation: TADOTable;
    dsWallboard: TDataSource;
    dsDispseq: TDataSource;
    dsDispColor: TDataSource;
    dsItemType: TDataSource;
    dsSrvGroup: TDataSource;
    dsWallboardLocation: TDataSource;
    qrySetCombo: TADOQuery;
    qryDispColor: TADOQuery;
    tblMakeCodeByIDNO: TADOTable;
    tblMakeCodeByIDNOIDNO: TIntegerField;
    tblMakeCodeByIDNODelay: TWordField;
    tblMakeCodeByIDNOItemID1: TWideStringField;
    tblMakeCodeByIDNOItemID2: TWideStringField;
    tblMakeCodeByIDNOItemID3: TWideStringField;
    tblMakeCodeByIDNOItemID4: TWideStringField;
    tblMakeCodeByIDNOItemID5: TWideStringField;
    tblMakeCodeByIDNOItemID6: TWideStringField;
    tblMakeCodeByIDNOItemID7: TWideStringField;
    tblMakeCodeByIDNOValue1: TWideStringField;
    tblMakeCodeByIDNOValue2: TWideStringField;
    tblMakeCodeByIDNOValue3: TWideStringField;
    tblMakeCodeByIDNOValue4: TWideStringField;
    tblMakeCodeByIDNOValue5: TWideStringField;
    tblMakeCodeByIDNOValue6: TWideStringField;
    tblMakeCodeByIDNOValue7: TWideStringField;
    tblMakeCodeByIDNOItemName1: TStringField;
    tblMakeCodeByIDNOItemName2: TStringField;
    tblMakeCodeByIDNOItemName3: TStringField;
    tblMakeCodeByIDNOItemName4: TStringField;
    tblMakeCodeByIDNOItemName5: TStringField;
    tblMakeCodeByIDNOItemName6: TStringField;
    tblMakeCodeByIDNOItemName7: TStringField;
    InletCheckout: TADOQuery;
    FixtimeCheckOn: TADOQuery;
    FixtimeCheckOut: TADOQuery;
    CycleCheckout: TADOQuery;
    CycleCheckDay: TADOQuery;
    CycleCheckweek: TADOQuery;
    CycleCheckmonth: TADOQuery;
    qryGetInlet: TADOQuery;
    qryGetFixtime: TADOQuery;
    qryGetCycle: TADOQuery;
    tblMakeCodeByIDNOGrpVDNSeq: TWideStringField;
    tblMakeCodeByIDNOGrpVDNColor: TWordField;
    tblMakeCodeByIDNOGrpVDNSize: TWordField;
    tblMakeCodeByIDNOGrpName: TStringField;
    tblVDN: TADOTable;
    tblMakeCodeByIDNOVDNName: TStringField;
    dsVDN: TDataSource;
    dsItemValue: TDataSource;
    qryWallboard: TADOQuery;
    CycleCheckDayOut: TADOQuery;
    CycleCheckWeekOut: TADOQuery;
    CycleCheckMonthOut: TADOQuery;
    procedure DataModuleDestroy(Sender: TObject);
    procedure tblDispseqNewRecord(DataSet: TDataSet);
    procedure tblDispseqBeforeDelete(DataSet: TDataSet);
    procedure tblDispseqAfterDelete(DataSet: TDataSet);
    procedure tblDispseqAfterPost(DataSet: TDataSet);
    procedure tblWallboardLocationBeforeDelete(DataSet: TDataSet);
    procedure tblWallboardLocationBeforeEdit(DataSet: TDataSet);
    procedure tblWallboardLocationAfterDelete(DataSet: TDataSet);
    procedure tblWallboardLocationAfterPost(DataSet: TDataSet);
    procedure tblItemTypeAfterPost(DataSet: TDataSet);
    procedure tblSrvGroupAfterPost(DataSet: TDataSet);
    procedure tblWallboardAfterPost(DataSet: TDataSet);
    procedure tblSrvGroupBeforeDelete(DataSet: TDataSet);
    procedure tblSrvGroupAfterDelete(DataSet: TDataSet);
    procedure tblSrvGroupNewRecord(DataSet: TDataSet);
    procedure tblVDNNewRecord(DataSet: TDataSet);
    procedure tblVDNAfterDelete(DataSet: TDataSet);
    procedure tblVDNAfterPost(DataSet: TDataSet);
    procedure tblVDNBeforeDelete(DataSet: TDataSet);
    procedure tblItemTypeBeforeDelete(DataSet: TDataSet);
    procedure tblDispseqBeforePost(DataSet: TDataSet);
  private
    { Private declarations }
  public
    procedure UpdateDBFlag;
  end;

var
  dmTable: TdmTable;
  iDelIDNO: Integer;
  sDelIp, sOldIp: string;
  sDelGrpSeq, sDelVDNSeq: string;

implementation

uses UT_Main;

{$R *.DFM}

procedure TdmTable.DataModuleDestroy(Sender: TObject);
var i: Integer;
begin
  for i := 0 to ComponentCount - 1 do
    if Components[i] is TADOTable then
      TADOTable(Components[i]).Close
    else if Components[i] is TADOQuery then
      TADOQuery(Components[i]).Close;
  connMain.Close;
end;

procedure TdmTable.tblDispseqNewRecord(DataSet: TDataSet);
var qry: TADOQuery;
begin
  qry := TADOQuery.Create(nil);
  try
    qry.Connection := connMain;
    qry.SQL.Text := 'Select MAX(IDNO) As MaxIDNO From Dispseq';
    qry.Open;
    if not qry.IsEmpty then
      tblDispseq.FieldByName('IDNO').AsInteger := qry.FieldByName('MaxIDNO').AsInteger + 1
    else
      tblDispseq.FieldByName('IDNO').AsInteger := 1;

    tblDispseq.FieldByName('Delay').AsInteger := 1; 
    tblDispseq.FieldByName('GrpVDNColor').AsInteger := 1; 
  finally
    qry.Free;
  end;
end;

procedure TdmTable.tblDispseqBeforeDelete(DataSet: TDataSet);
begin
  iDelIDNO := tblDispseq.FieldByName('IDNO').AsInteger;
end;

procedure TdmTable.tblDispseqAfterDelete(DataSet: TDataSet);
var qry: TADOQuery;
  i: Integer;
begin
  qry := TADOQuery.Create(nil);
  try
    qry.Connection := connMain;
    qry.SQL.Text := 'Update Dispseq Set IDNO = IDNO - 1 Where IDNO > :IDNO';
    qry.Parameters.ParamValues['IDNO'] := iDelIDNO;
    qry.ExecSQL;

    for i := 1 to 20 do begin //  Wallboard tQR IDNO? ȳ] 0
      qry.SQL.Text := 'Update Wallboard Set IDNO' + IntToStr(i)
        + ' = 0 Where IDNO' + IntToStr(i) + ' = :IDNO';
      qry.Parameters.ParamValues['IDNO'] := iDelIDNO;
      qry.ExecSQL;
    end;
    for i := 1 to 20 do begin //  Wallboard QR IDNO? ȴ 1
      qry.SQL.Text := 'Update Wallboard Set IDNO' + IntToStr(i)
        + ' = IDNO' + IntToStr(i) + ' - 1 Where IDNO' + IntToStr(i) + ' > :IDNO';
      qry.Parameters.ParamValues['IDNO'] := iDelIDNO;
      qry.ExecSQL;
    end;
    tblWallboard.Requery();
  finally
    qry.Free;
  end;
end;

procedure TdmTable.tblDispseqAfterPost(DataSet: TDataSet);
var CurrIDNO: Integer;
begin
  CurrIDNO := tblDispseq.FieldByName('IDNO').AsInteger;
  try
    tblDispseq.DisableControls;
    tblDispseq.Requery();
    tblDispseq.Locate('IDNO', CurrIDNO, []);
  finally
    tblDispseq.EnableControls;
  end;
end;

procedure TdmTable.tblWallboardLocationBeforeDelete(DataSet: TDataSet);
begin
  sDelIp := tblWallboardLocation.FieldByName('IP').AsString;
end;

procedure TdmTable.tblWallboardLocationBeforeEdit(DataSet: TDataSet);
begin
  sOldIp := tblWallboardLocation.FieldByName('IP').AsString;
end;

procedure TdmTable.tblWallboardLocationAfterDelete(DataSet: TDataSet);
var qry: TADOQuery;
begin
  qry := TADOQuery.Create(nil);
  try
    qry.Connection := connMain;
    qry.SQL.Text := 'Delete From Wallboard Where IP = :IP';
    qry.Parameters.ParamValues['IP'] := sDelIP;
    qry.ExecSQL;

    frmMain.SetComboItem;
    tblWallboard.Requery();
  finally
    qry.Free;
  end;
end;

procedure TdmTable.tblWallboardLocationAfterPost(DataSet: TDataSet);
var qry: TADOQuery;
begin
  qry := TADOQuery.Create(nil);
  try
    qry.Connection := connMain;
    qry.SQL.Text := 'Update Wallboard Set IP = :NewIP Where IP = :OldIP';
    qry.Parameters.ParamValues['NewIP'] := tblWallboardLocation.FieldByName('IP').AsString;
    qry.Parameters.ParamValues['OldIP'] := sOldIP;
    qry.ExecSQL;

    frmMain.SetComboItem;
    tblWallboard.Requery();
  finally
    qry.Free;
  end;
  tblWallboardLocation.Requery();
end;

procedure TdmTable.tblItemTypeAfterPost(DataSet: TDataSet);
begin
  frmMain.SetComboItem;
  tblDispseq.Requery();
end;

procedure TdmTable.tblSrvGroupAfterPost(DataSet: TDataSet);
var CurrSeq: string;
  CurrIDNO: Integer;
begin
  CurrSeq := tblSrvGroup.FieldByName('GrpSeq').AsString;
  CurrIDNO := tblDispseq.FieldByName('IDNO').AsInteger;
  tblSrvGroup.Locate('GrpSeq', CurrSeq, []);

  frmMain.SetComboItem;
  tblDispseq.Requery();
  tblDispseq.Locate('IDNO', CurrIDNO, []);
end;

procedure TdmTable.UpdateDBFlag;
var nYear, nMon, nCurWeekDay, nCurMonDay: Word;
	dt: TDateTime;
begin
  nCurWeekDay := DayOfWeek(Now) -1;
  if nCurWeekDay = 0 then
    nCurWeekDay := 7;
  DecodeDate(Now, nYear, nMon, nCurMonDay);
  dt := Now;

  // ----------- Process Inlet ---------------
  InletCheckOut.Parameters.ParamValues['CurDaTm'] := dt;
  InletCheckOut.ExecSQL;

  // ----------- Process FixTime ---------------
  FixtimeCheckOut.Parameters.ParamValues['CurDaTm'] := dt;
  FixtimeCheckOut.ExecSQL;

  FixtimeCheckOn.Parameters.ParamValues['CurDaTm_1'] := dt;
  FixtimeCheckOn.Parameters.ParamValues['CurDaTm_2'] := dt;
  FixtimeCheckOn.ExecSQL;

  // ----------- Process Cycle ---------------
  CycleCheckOut.ExecSQL;

  CycleCheckDay.Parameters.ParamValues['CurDate_1'] := IntToStr(Trunc(dt));
  CycleCheckDay.Parameters.ParamValues['CurDate_2'] := IntToStr(Trunc(dt));
  CycleCheckDay.Parameters.ParamValues['CurTime_1'] := FloatToStr(Frac(dt));
  CycleCheckDay.Parameters.ParamValues['CurTime_2'] := FloatToStr(Frac(dt));
  CycleCheckDay.ExecSQL;

  CycleCheckWeek.Parameters.ParamValues['WeekDay'] := nCurWeekDay;
  CycleCheckWeek.Parameters.ParamValues['CurDate_1'] := IntToStr(Trunc(dt));
  CycleCheckWeek.Parameters.ParamValues['CurDate_2'] := IntToStr(Trunc(dt));
  CycleCheckWeek.Parameters.ParamValues['CurTime_1'] := FloatToStr(Frac(dt));
  CycleCheckWeek.Parameters.ParamValues['CurTime_2'] := FloatToStr(Frac(dt));
  CycleCheckWeek.ExecSQL;

  CycleCheckMonth.Parameters.ParamValues['MonDay'] := nCurMonDay;
  CycleCheckMonth.Parameters.ParamValues['CurDate_1'] := IntToStr(Trunc(dt));
  CycleCheckMonth.Parameters.ParamValues['CurDate_2'] := IntToStr(Trunc(dt));
  CycleCheckMonth.Parameters.ParamValues['CurTime_1'] := FloatToStr(Frac(dt));
  CycleCheckMonth.Parameters.ParamValues['CurTime_2'] := FloatToStr(Frac(dt));
  CycleCheckMonth.ExecSQL;


  CycleCheckDayOut.Parameters.ParamValues['CurDate_1'] := IntToStr(Trunc(dt));
  CycleCheckDayOut.Parameters.ParamValues['CurDate_2'] := IntToStr(Trunc(dt));
  CycleCheckDayOut.Parameters.ParamValues['CurTime'] := FloatToStr(Frac(dt));
  CycleCheckDayOut.ExecSQL;

  CycleCheckWeekOut.Parameters.ParamValues['CurDate_1'] := IntToStr(Trunc(dt));
  CycleCheckWeekOut.Parameters.ParamValues['CurDate_2'] := IntToStr(Trunc(dt));
  CycleCheckWeekOut.Parameters.ParamValues['CurTime'] := FloatToStr(Frac(dt));
  CycleCheckWeekOut.ExecSQL;

  CycleCheckMonthOut.Parameters.ParamValues['CurDate_1'] := IntToStr(Trunc(dt));
  CycleCheckMonthOut.Parameters.ParamValues['CurDate_2'] := IntToStr(Trunc(dt));
  CycleCheckMonthOut.Parameters.ParamValues['CurTime'] := FloatToStr(Frac(dt));
  CycleCheckMonthOut.ExecSQL;
end;

procedure TdmTable.tblWallboardAfterPost(DataSet: TDataSet);
var i, j: Integer;
begin
  for i := 0 to High(aLed) do
    if aLed[i].IP = tblWallboard.FieldByName('IP').AsString then
      for j := 1 to 20 do
        aLed[i].IDNOArray[j-1] := tblWallboard.FieldByName('IDNO' + IntToStr(j)).AsInteger;
end;

procedure TdmTable.tblSrvGroupBeforeDelete(DataSet: TDataSet);
begin
  sDelGrpSeq := tblSrvGroup.FieldByName('GrpSeq').AsString;
end;

procedure TdmTable.tblSrvGroupAfterDelete(DataSet: TDataSet);
var qry, qryUpd: TADOQuery;
  i, TmpSeq: Integer;
begin
  qry := TADOQuery.Create(nil);
  qryUpd := TADOQuery.Create(nil);
  try
    qry.Connection := connMain;
    qryUpd.Connection := connMain;
    qry.SQL.Text := 'Select * From Dispseq Order By IDNO';
    qry.Open;
    while not qry.Eof do
      if qry.FieldByName('GrpVDNSeq').AsString = sDelGrpSeq then begin
        for i := 1 to 20 do begin
          qryUpd.SQL.Text := 'Update Wallboard Set IDNO' + IntToStr(i)
            + ' = 0 Where IDNO' + IntToStr(i) + ' = '
            + IntToStr(qry.FieldByName('IDNO').AsInteger);
          qryUpd.ExecSQL;
        end;
        qry.Delete;
      end else
        qry.Next;

    qry.Close;
    qry.SQL.Text := 'Select * From SrvGroup Where GrpSeq > :GrpSeq Order By GrpSeq';
    qry.Parameters.ParamValues['GrpSeq'] := sDelGrpSeq;
    qry.Open;
    while not qry.Eof do begin
      TmpSeq := StrToInt(Copy(qry.FieldByName('GrpSeq').AsString, 2, Length(qry.FieldByName('GrpSeq').AsString)-1));
      qry.Edit;
      qry.FieldByName('GrpSeq').AsString := 'G' + IntToStr(TmpSeq+1);
      qry.Post;
      qry.Next;
    end;
  finally
    qry.Close;
    qryUpd.Close;
    qry.Free;
    qryUpd.Free;
  end;

  tblSrvGroup.Requery();
end;

procedure TdmTable.tblSrvGroupNewRecord(DataSet: TDataSet);
begin
  tblSrvGroup.FieldByName('GrpSeq').AsString := 'G'
    + IntToStr(tblSrvGroup.RecordCount + 1);
end;

procedure TdmTable.tblVDNNewRecord(DataSet: TDataSet);
begin
  tblVDN.FieldByName('VDNSeq').AsString := 'V' + IntToStr(tblVDN.RecordCount + 1);
end;

procedure TdmTable.tblVDNAfterDelete(DataSet: TDataSet);
var qry, qryUpd: TADOQuery;
  i, TmpSeq: Integer;
begin
  qry := TADOQuery.Create(nil);
  qryUpd := TADOQuery.Create(nil);
  try
    qry.Connection := connMain;
    qryUpd.Connection := connMain;
    qry.SQL.Text := 'Select * From Dispseq Order By IDNO';
    qry.Open;
    while not qry.Eof do
      if qry.FieldByName('GrpVDNSeq').AsString = sDelGrpSeq then begin
        for i := 1 to 20 do begin
          qryUpd.SQL.Text := 'Update Wallboard Set IDNO' + IntToStr(i)
            + ' = 0 Where IDNO' + IntToStr(i) + ' = '
            + IntToStr(qry.FieldByName('IDNO').AsInteger);
          qryUpd.ExecSQL;
        end;
        qry.Delete;
      end else
        qry.Next;

    qry.Close;
    qry.SQL.Text := 'Select * From VDN Where VDNSeq > :VDNSeq Order By VDNSeq';
    qry.Parameters.ParamValues['VDNSeq'] := sDelVDNSeq;
    qry.Open;
    while not qry.Eof do begin
      TmpSeq := StrToInt(Copy(qry.FieldByName('VDNSeq').AsString, 2, Length(qry.FieldByName('VDNSeq').AsString)-1));
      qry.Edit;
      qry.FieldByName('VDNSeq').AsString := 'V' + IntToStr(TmpSeq+1);
      qry.Post;
      qry.Next;
    end;
  finally
    qry.Close;
    qryUpd.Close;
    qry.Free;
    qryUpd.Free;
  end;

  tblVDN.Requery();
end;

procedure TdmTable.tblVDNAfterPost(DataSet: TDataSet);
var CurrSeq: string;
  CurrIDNO: Integer;
begin
  CurrSeq := tblVDN.FieldByName('VDNSeq').AsString;
  CurrIDNO := tblDispseq.FieldByName('IDNO').AsInteger;
  tblVDN.Locate('VDNSeq', CurrSeq, []);

  frmMain.SetComboItem;
  tblDispseq.Requery();
  tblDispseq.Locate('IDNO', CurrIDNO, []);
end;

procedure TdmTable.tblVDNBeforeDelete(DataSet: TDataSet);
begin
  sDelVDNSeq := tblVDN.FieldByName('VDNSeq').AsString;
end;

procedure TdmTable.tblItemTypeBeforeDelete(DataSet: TDataSet);
begin
  Abort;
end;

procedure TdmTable.tblDispseqBeforePost(DataSet: TDataSet);
var i: integer;
begin
  for i := 1 to 7 do
    if tblDispseq.FieldByName('ItemId' + IntToStr(i)).AsString = '15' then
      tblDispseq.FieldByName('Value' + IntToStr(i)).AsString := ''
    else
      tblDispseq.FieldByName('Value' + IntToStr(i)).AsString := '0';
end;

end.
